diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/test/tcp-ledbat-test.cc ns-3.47/src/internet/test/tcp-ledbat-test.cc
--- ns-3.46/src/internet/test/tcp-ledbat-test.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/test/tcp-ledbat-test.cc	2026-02-16 16:08:49.626230000 -0800
@@ -4,6 +4,7 @@
  * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Ankit Deepak <adadeepak8@gmail.com>
+ * Modified by: S B L Prateek <sblprateek@gmail.com>
  *
  */
 
@@ -33,8 +34,7 @@
      * @param segmentSize segment size
      * @param ssThresh slow start threshold
      * @param segmentsAcked segments acked
-     * @param highTxMark high tx mark
-     * @param lastAckedSeq last acked seq
+     * @param bytesInFlight bytes in flight
      * @param rtt RTT
      * @param name Name of the test
      */
@@ -42,34 +42,27 @@
                        uint32_t segmentSize,
                        uint32_t ssThresh,
                        uint32_t segmentsAcked,
-                       SequenceNumber32 highTxMark,
-                       SequenceNumber32 lastAckedSeq,
+                       uint32_t bytesInFlight,
                        Time rtt,
                        const std::string& name);
 
   private:
     void DoRun() override;
-    /**
-     * @brief Execute the test
-     */
-    void ExecuteTest();
 
-    uint32_t m_cWnd;                 //!< cWnd
-    uint32_t m_segmentSize;          //!< segment size
-    uint32_t m_segmentsAcked;        //!< segments acked
-    uint32_t m_ssThresh;             //!< ss thresh
-    Time m_rtt;                      //!< rtt
-    SequenceNumber32 m_highTxMark;   //!< high tx mark
-    SequenceNumber32 m_lastAckedSeq; //!< last acked seq
-    Ptr<TcpSocketState> m_state;     //!< state
+    uint32_t m_cWnd;             //!< cWnd
+    uint32_t m_segmentSize;      //!< segment size
+    uint32_t m_segmentsAcked;    //!< segments acked
+    uint32_t m_ssThresh;         //!< ss thresh
+    Time m_rtt;                  //!< rtt
+    uint32_t m_bytesInFlight;    //!< bytes in flight
+    Ptr<TcpSocketState> m_state; //!< state
 };
 
 TcpLedbatToNewReno::TcpLedbatToNewReno(uint32_t cWnd,
                                        uint32_t segmentSize,
                                        uint32_t ssThresh,
                                        uint32_t segmentsAcked,
-                                       SequenceNumber32 highTxMark,
-                                       SequenceNumber32 lastAckedSeq,
+                                       uint32_t bytesInFlight,
                                        Time rtt,
                                        const std::string& name)
     : TestCase(name),
@@ -78,35 +71,24 @@
       m_segmentsAcked(segmentsAcked),
       m_ssThresh(ssThresh),
       m_rtt(rtt),
-      m_highTxMark(highTxMark),
-      m_lastAckedSeq(lastAckedSeq)
+      m_bytesInFlight(bytesInFlight)
 {
 }
 
 void
 TcpLedbatToNewReno::DoRun()
 {
-    Simulator::Schedule(Seconds(0), &TcpLedbatToNewReno::ExecuteTest, this);
-    Simulator::Run();
-    Simulator::Destroy();
-}
-
-void
-TcpLedbatToNewReno::ExecuteTest()
-{
     m_state = CreateObject<TcpSocketState>();
     m_state->m_cWnd = m_cWnd;
     m_state->m_ssThresh = m_ssThresh;
     m_state->m_segmentSize = m_segmentSize;
-    m_state->m_highTxMark = m_highTxMark;
-    m_state->m_lastAckedSeq = m_lastAckedSeq;
+    m_state->m_bytesInFlight = m_bytesInFlight;
 
     Ptr<TcpSocketState> state = CreateObject<TcpSocketState>();
     state->m_cWnd = m_cWnd;
     state->m_ssThresh = m_ssThresh;
     state->m_segmentSize = m_segmentSize;
-    state->m_highTxMark = m_highTxMark;
-    state->m_lastAckedSeq = m_lastAckedSeq;
+    state->m_bytesInFlight = m_bytesInFlight;
 
     Ptr<TcpLedbat> cong = CreateObject<TcpLedbat>();
     cong->IncreaseWindow(m_state, m_segmentsAcked);
@@ -117,118 +99,48 @@
     NS_TEST_ASSERT_MSG_EQ(m_state->m_cWnd.Get(),
                           state->m_cWnd.Get(),
                           "cWnd has not updated correctly");
+
+    Simulator::Destroy();
 }
 
 /**
  * @ingroup internet-test
  *
- * @brief Test to validate cWnd increment in LEDBAT
+ * @brief Test to validate cWnd increment/decrement in LEDBAT Congestion Avoidance Phase
  */
-class TcpLedbatIncrementTest : public TestCase
+class TcpLedbatCongestionAvoidanceTest : public TestCase
 {
   public:
     /**
-     * @brief Constructor
-     *
-     * @param cWnd congestion window
-     * @param segmentSize segment size
-     * @param ssThresh slow start threshold
-     * @param segmentsAcked segments acked
-     * @param highTxMark high tx mark
-     * @param lastAckedSeq last acked seq
-     * @param rtt RTT
-     * @param name Name of the test
-     */
-    TcpLedbatIncrementTest(uint32_t cWnd,
-                           uint32_t segmentSize,
-                           uint32_t ssThresh,
-                           uint32_t segmentsAcked,
-                           SequenceNumber32 highTxMark,
-                           SequenceNumber32 lastAckedSeq,
-                           Time rtt,
-                           const std::string& name);
-
-  private:
-    void DoRun() override;
-    /**
-     * @brief Execute the test
+     * @brief Type of expected CWND behavior in LEDBAT congestion avoidance
      */
-    void ExecuteTest();
-
-    uint32_t m_cWnd;                 //!< cWnd
-    uint32_t m_segmentSize;          //!< segment size
-    uint32_t m_segmentsAcked;        //!< segments acked
-    uint32_t m_ssThresh;             //!< ss thresh
-    Time m_rtt;                      //!< rtt
-    SequenceNumber32 m_highTxMark;   //!< high tx mark
-    SequenceNumber32 m_lastAckedSeq; //!< last acked seq
-    Ptr<TcpSocketState> m_state;     //!< state
-};
-
-TcpLedbatIncrementTest::TcpLedbatIncrementTest(uint32_t cWnd,
-                                               uint32_t segmentSize,
-                                               uint32_t ssThresh,
-                                               uint32_t segmentsAcked,
-                                               SequenceNumber32 highTxMark,
-                                               SequenceNumber32 lastAckedSeq,
-                                               Time rtt,
-                                               const std::string& name)
-    : TestCase(name),
-      m_cWnd(cWnd),
-      m_segmentSize(segmentSize),
-      m_segmentsAcked(segmentsAcked),
-      m_ssThresh(ssThresh),
-      m_rtt(rtt),
-      m_highTxMark(highTxMark),
-      m_lastAckedSeq(lastAckedSeq)
-{
-}
-
-void
-TcpLedbatIncrementTest::DoRun()
-{
-    Simulator::Schedule(Seconds(0), &TcpLedbatIncrementTest::ExecuteTest, this);
-    Simulator::Run();
-    Simulator::Destroy();
-}
-
-void
-TcpLedbatIncrementTest::ExecuteTest()
-{
-    m_state = CreateObject<TcpSocketState>();
-    m_state->m_cWnd = m_cWnd;
-    m_state->m_ssThresh = m_ssThresh;
-    m_state->m_segmentSize = m_segmentSize;
-    m_state->m_highTxMark = m_highTxMark;
-    m_state->m_lastAckedSeq = m_lastAckedSeq;
-
-    Ptr<TcpLedbat> cong = CreateObject<TcpLedbat>();
-    cong->SetAttribute("SSParam", StringValue("no"));
-    cong->SetAttribute("NoiseFilterLen", UintegerValue(1));
-
-    m_state->m_rcvTimestampValue = 2;
-    m_state->m_rcvTimestampEchoReply = 1;
-    cong->PktsAcked(m_state, m_segmentsAcked, m_rtt);
-
-    m_state->m_rcvTimestampValue = 7;
-    m_state->m_rcvTimestampEchoReply = 4;
-    cong->PktsAcked(m_state, m_segmentsAcked, m_rtt);
-
-    cong->IncreaseWindow(m_state, m_segmentsAcked);
-
-    m_cWnd = m_cWnd + ((0.98 * m_segmentsAcked * m_segmentSize * m_segmentSize) / m_cWnd);
-
-    NS_TEST_ASSERT_MSG_EQ(m_state->m_cWnd.Get(), m_cWnd, "cWnd has not updated correctly");
-}
+    enum TestType
+    {
+        /**
+         * To enable check for CWND increases because the measured queue delay is
+         * below the target delay (positive offset).
+         */
+        INCREMENT_TEST,
+
+        /**
+         * To enable check that CWND increase is limited by the maximum allowed CWND,
+         * computed from flight size before ack (bytesInFlight + segmentsAcked * segmentSize).
+         */
+        MAX_CWND_TEST,
+
+        /**
+         * To enable check for CWND decreases because the measured queue delay is
+         * above the target delay (negative offset).
+         */
+        DECREMENT_TEST,
+
+        /**
+         * To enable check that CWND decrease is limited by the minimum CWND constraint
+         * (MinCwnd × segmentSize).
+         */
+        MIN_CWND_TEST
+    };
 
-/**
- * @ingroup internet-test
- *
- * @brief Test to validate cWnd decrement in LEDBAT
- */
-class TcpLedbatDecrementTest : public TestCase
-{
-  public:
     /**
      * @brief Constructor
      *
@@ -236,94 +148,212 @@
      * @param segmentSize segment size
      * @param ssThresh slow start threshold
      * @param segmentsAcked segments acked
-     * @param highTxMark high tx mark
-     * @param lastAckedSeq last acked seq
+     * @param bytesInFlight bytes in flight
      * @param rtt RTT
+     * @param rcvTimestampValue Receive timestamp for delay estimation
+     * @param currentRcvTimestampEchoReply Echo reply timestamp for current delay
+     * @param testType Expected test behavior
      * @param name Name of the test
      */
-    TcpLedbatDecrementTest(uint32_t cWnd,
-                           uint32_t segmentSize,
-                           uint32_t ssThresh,
-                           uint32_t segmentsAcked,
-                           SequenceNumber32 highTxMark,
-                           SequenceNumber32 lastAckedSeq,
-                           Time rtt,
-                           const std::string& name);
+
+    TcpLedbatCongestionAvoidanceTest(uint32_t cWnd,
+                                     uint32_t segmentSize,
+                                     uint32_t ssThresh,
+                                     uint32_t segmentsAcked,
+                                     uint32_t bytesInFlight,
+                                     Time rtt,
+                                     uint32_t rcvTimestampValue,
+                                     uint32_t currentRcvTimestampEchoReply,
+                                     TestType testType,
+                                     const std::string& name);
 
   private:
     void DoRun() override;
-    /**
-     * @brief Execute the test
-     */
-    void ExecuteTest();
 
-    uint32_t m_cWnd;                 //!< cWnd
-    uint32_t m_segmentSize;          //!< segment size
-    uint32_t m_segmentsAcked;        //!< segments acked
-    uint32_t m_ssThresh;             //!< ss thresh
-    Time m_rtt;                      //!< rtt
-    SequenceNumber32 m_highTxMark;   //!< high tx mark
-    SequenceNumber32 m_lastAckedSeq; //!< last acked seq
-    Ptr<TcpSocketState> m_state;     //!< state
+    uint32_t m_cWnd;                         //!< cWnd
+    uint32_t m_segmentSize;                  //!< segment size
+    uint32_t m_segmentsAcked;                //!< segments acked
+    uint32_t m_ssThresh;                     //!< ss thresh
+    Time m_rtt;                              //!< rtt
+    uint32_t m_bytesInFlight;                //!< bytes in flight (after ACK)
+    uint32_t m_rcvTimestampValue;            //!< received timestamp value
+    uint32_t m_currentRcvTimestampEchoReply; //!< current echoed timestamp value
+    TestType m_testType;                     //!< test type
+    Ptr<TcpSocketState> m_state;             //!< state
 };
 
-TcpLedbatDecrementTest::TcpLedbatDecrementTest(uint32_t cWnd,
-                                               uint32_t segmentSize,
-                                               uint32_t ssThresh,
-                                               uint32_t segmentsAcked,
-                                               SequenceNumber32 highTxMark,
-                                               SequenceNumber32 lastAckedSeq,
-                                               Time rtt,
-                                               const std::string& name)
+TcpLedbatCongestionAvoidanceTest::TcpLedbatCongestionAvoidanceTest(
+    uint32_t cWnd,
+    uint32_t segmentSize,
+    uint32_t ssThresh,
+    uint32_t segmentsAcked,
+    uint32_t bytesInFlight,
+    Time rtt,
+    uint32_t rcvTimestampValue,
+    uint32_t currentRcvTimestampEchoReply,
+    TestType testType,
+    const std::string& name)
     : TestCase(name),
       m_cWnd(cWnd),
       m_segmentSize(segmentSize),
       m_segmentsAcked(segmentsAcked),
       m_ssThresh(ssThresh),
       m_rtt(rtt),
-      m_highTxMark(highTxMark),
-      m_lastAckedSeq(lastAckedSeq)
-{
-}
-
-void
-TcpLedbatDecrementTest::DoRun()
+      m_bytesInFlight(bytesInFlight),
+      m_rcvTimestampValue(rcvTimestampValue),
+      m_currentRcvTimestampEchoReply(currentRcvTimestampEchoReply),
+      m_testType(testType)
 {
-    Simulator::Schedule(Seconds(0), &TcpLedbatDecrementTest::ExecuteTest, this);
-    Simulator::Run();
-    Simulator::Destroy();
 }
 
 void
-TcpLedbatDecrementTest::ExecuteTest()
+TcpLedbatCongestionAvoidanceTest::DoRun()
 {
-    UintegerValue minCwnd;
     m_state = CreateObject<TcpSocketState>();
     m_state->m_cWnd = m_cWnd;
     m_state->m_ssThresh = m_ssThresh;
     m_state->m_segmentSize = m_segmentSize;
-    m_state->m_highTxMark = m_highTxMark;
-    m_state->m_lastAckedSeq = m_lastAckedSeq;
+    m_state->m_bytesInFlight = m_bytesInFlight;
 
     Ptr<TcpLedbat> cong = CreateObject<TcpLedbat>();
+    cong->SetAttribute("Gain", DoubleValue(1.0)); // Default LEDBAT GAIN value as per RFC 6817
+    cong->SetAttribute("AllowedIncrease",
+                       DoubleValue(1.0)); // Default LEDBAT Allowed Increase value as per RFC 6817
     cong->SetAttribute("SSParam", StringValue("no"));
     cong->SetAttribute("NoiseFilterLen", UintegerValue(1));
-    cong->GetAttribute("MinCwnd", minCwnd);
+    cong->SetAttribute("MinCwnd", UintegerValue(2));
 
-    m_state->m_rcvTimestampValue = 2;
-    m_state->m_rcvTimestampEchoReply = 1;
+    // Establish base delay measurement (Base Delay = 40 - 20 = 20ms)
+    m_state->m_rcvTimestampValue = 40;
+    m_state->m_rcvTimestampEchoReply = 20;
     cong->PktsAcked(m_state, m_segmentsAcked, m_rtt);
 
-    m_state->m_rcvTimestampValue = 205;
-    m_state->m_rcvTimestampEchoReply = 6;
+    // Set current measured delay based on test parameters
+    m_state->m_rcvTimestampValue = m_rcvTimestampValue;
+    m_state->m_rcvTimestampEchoReply = m_currentRcvTimestampEchoReply;
     cong->PktsAcked(m_state, m_segmentsAcked, m_rtt);
 
-    cong->IncreaseWindow(m_state, m_segmentsAcked);
+    uint32_t oldCwnd = m_state->m_cWnd.Get();
+
+    // LEDBAT adjusts cwnd based on queuing delay relative to target:
+    // - When queuing delay < target: cwnd increases (positive offset)
+    // - When queuing delay > target: cwnd decreases (negative offset)
+    // - cwnd is bounded by max (flightSizeBeforeAck + ALLOWED_INCREASE * MSS)
+    //   and min (minCwnd * MSS)
 
-    m_cWnd = m_cWnd - ((0.98 * m_segmentsAcked * m_segmentSize * m_segmentSize) / m_cWnd);
-    m_cWnd = std::max(m_cWnd, static_cast<uint32_t>(m_segmentSize * minCwnd.Get()));
+    switch (m_testType)
+    {
+    case INCREMENT_TEST:
+        // Timestamps: rcvTimestamp=80, echoReply=20
+        // currentDelay = 80 - 20 = 60ms
+        // baseDelay = 20ms (established earlier: 40 - 20)
+        // queueDelay = currentDelay - baseDelay = 60 - 20 = 40ms
+        // offset = target - queueDelay = 100 - 40 = 60ms
+        // offset *= gain: offset = 60 * 1.0 = 60
+        // oldCwnd = 8676 bytes
+        // m_sndCwndCnt = offset * segmentsAcked * segmentSize
+        //              = 60 * 2 * 1446 = 173520
+        // inc = m_sndCwndCnt / (target * oldCwnd)
+        //     = 173520 / (100 * 8676) = 0.2
+        // newCwnd = oldCwnd + (inc * segmentSize)
+        //         = 8676 + (0.2 * 1446) = 8676 + 289.2 = 8965.2 ≈ 8965
+        // flightSizeBeforeAck = bytesInFlight + segmentsAcked * segmentSize
+        //                     = 5784 + 2 * 1446 = 8676
+        // maxCwnd = flightSizeBeforeAck + allowedIncrease * segmentSize
+        //         = 8676 + 1.0 * 1446 = 10122
+        // newCwnd = min(8965, 10122) = 8965
+        // newCwnd = max(8965, 2892) = 8965
+        // Final newCwnd = 8965 bytes
+        // increment = inc * segmentSize = 0.2 * 1446 = 289
+        cong->IncreaseWindow(m_state, m_segmentsAcked);
+        NS_TEST_ASSERT_MSG_EQ(m_state->m_cWnd.Get(),
+                              oldCwnd + 289,
+                              "cWnd of 8676 should increase by 289");
+        break;
+
+    case MAX_CWND_TEST:
+        // Timestamps: rcvTimestamp=80, echoReply=20
+        // currentDelay = 80 - 20 = 60ms
+        // baseDelay = 20ms (established earlier: 40 - 20)
+        // queueDelay = currentDelay - baseDelay = 60 - 20 = 40ms
+        // offset = target - queueDelay = 100 - 40 = 60ms
+        // offset *= gain: offset = 60 * 1.0 = 60
+        // oldCwnd = 8676 bytes, bytesInFlight = 4338 bytes
+        // m_sndCwndCnt = offset * segmentsAcked * segmentSize
+        //              = 60 * 2 * 1446 = 173520
+        // inc = m_sndCwndCnt / (target * oldCwnd)
+        //     = 173520 / (100 * 8676) = 0.2
+        // newCwnd = oldCwnd + (inc * segmentSize)
+        //         = 8676 + (0.2 * 1446) = 8676 + 289.2 = 8965.2 ≈ 8965
+        // flightSizeBeforeAck = bytesInFlight + segmentsAcked * segmentSize
+        //                     = 4338 + 2 * 1446 = 7230
+        // maxCwnd = flightSizeBeforeAck + allowedIncrease * segmentSize
+        //         = 7230 + 1.0 * 1446 = 8676
+        // Final newCwnd = min(8965, 8676) = 8676 bytes (clamped by maxCwnd)
+        cong->IncreaseWindow(m_state, m_segmentsAcked);
+        NS_TEST_ASSERT_MSG_EQ(m_state->m_cWnd.Get(), 8676, "cWnd should be limited by maxCwnd");
+        break;
+
+    case DECREMENT_TEST:
+        // Timestamps: rcvTimestamp=160, echoReply=20
+        // currentDelay = 160 - 20 = 140ms
+        // baseDelay = 20ms (established earlier: 40 - 20)
+        // queueDelay = currentDelay - baseDelay = 140 - 20 = 120ms
+        // offset = target - queueDelay = 100 - 120 = -20ms
+        // offset *= gain: offset = -20 * 1.0 = -20
+        // oldCwnd = 8676 bytes
+        // m_sndCwndCnt = offset * segmentsAcked * segmentSize
+        //              = -20 * 2 * 1446 = -57840
+        // inc = m_sndCwndCnt / (target * oldCwnd)
+        //     = -57840 / (100 * 8676) = -0.06667
+        // newCwnd = oldCwnd + (inc * segmentSize)
+        //         = 8676 + (-0.06667 * 1446) = 8676 - 96.4 = 8579.6 ≈ 8579
+        // flightSizeBeforeAck = bytesInFlight + segmentsAcked * segmentSize
+        //                     = 5784 + 2 * 1446 = 8676
+        // maxCwnd = flightSizeBeforeAck + allowedIncrease * segmentSize
+        //         = 8676 + 1.0 * 1446 = 10122
+        // newCwnd = min(8579, 10122) = 8579
+        // newCwnd = max(8579, 2892) = 8579
+        // Final newCwnd = 8579 bytes
+        // decrement = inc * segmentSize = -0.06667 * 1446 = -97
+        cong->IncreaseWindow(m_state, m_segmentsAcked);
+        NS_TEST_ASSERT_MSG_EQ(m_state->m_cWnd.Get(),
+                              oldCwnd - 97,
+                              "cWnd of 8676 should decrease by 97");
+        break;
+
+    case MIN_CWND_TEST:
+        // Timestamps: rcvTimestamp=160, echoReply=20
+        // currentDelay = 160 - 20 = 140ms
+        // baseDelay = 20ms (established earlier: 40 - 20)
+        // queueDelay = currentDelay - baseDelay = 140 - 20 = 120ms
+        // offset = target - queueDelay = 100 - 120 = -20ms
+        // offset *= gain: offset = -20 * 1.0 = -20
+        // oldCwnd = 2892 bytes, minCwnd = 2 segments = 2892 bytes
+        // m_sndCwndCnt = offset * segmentsAcked * segmentSize
+        //              = -20 * 2 * 1446 = -57840
+        // inc = m_sndCwndCnt / (target * oldCwnd)
+        //     = -57840 / (100 * 2892) = -0.2
+        // newCwnd = oldCwnd + (inc * segmentSize)
+        //         = 2892 + (-0.2 * 1446) = 2892 - 289.2 = 2602.8 ≈ 2602
+        // flightSizeBeforeAck = bytesInFlight + segmentsAcked * segmentSize
+        //                     = 5784 + 2 * 1446 = 8676
+        // maxCwnd = flightSizeBeforeAck + allowedIncrease * segmentSize
+        //         = 8676 + 1.0 * 1446 = 10122
+        // newCwnd = min(2602, 10122) = 2602
+        // Final newCwnd = max(2602, 2892) = 2892 bytes (clamped by minCwnd)
+        cong->IncreaseWindow(m_state, m_segmentsAcked);
+        NS_TEST_ASSERT_MSG_EQ(m_state->m_cWnd.Get(),
+                              2 * 1446,
+                              "cWnd should be clamped to minCwnd (2892)");
+        break;
+
+    default:
+        NS_FATAL_ERROR("Unknown Test Type");
+        break;
+    }
 
-    NS_TEST_ASSERT_MSG_EQ(m_state->m_cWnd.Get(), m_cWnd, "cWnd has not updated correctly");
+    Simulator::Destroy();
 }
 
 /**
@@ -341,8 +371,7 @@
                                            1446,
                                            4 * 1446,
                                            2,
-                                           SequenceNumber32(4753),
-                                           SequenceNumber32(3216),
+                                           1446,
                                            MilliSeconds(100),
                                            "LEDBAT falls to New Reno for slowstart"),
                     TestCase::Duration::QUICK);
@@ -350,28 +379,57 @@
                                            1446,
                                            2 * 1446,
                                            2,
-                                           SequenceNumber32(4753),
-                                           SequenceNumber32(3216),
+                                           1446,
                                            MilliSeconds(100),
                                            "LEDBAT falls to New Reno if timestamps are not found"),
                     TestCase::Duration::QUICK);
-        AddTestCase(new TcpLedbatIncrementTest(2 * 1446,
-                                               1446,
-                                               4 * 1446,
-                                               2,
-                                               SequenceNumber32(4753),
-                                               SequenceNumber32(3216),
-                                               MilliSeconds(100),
-                                               "LEDBAT increment test"),
+        AddTestCase(
+            new TcpLedbatCongestionAvoidanceTest(6 * 1446,
+                                                 1446,
+                                                 4 * 1446,
+                                                 2,
+                                                 4 * 1446,
+                                                 MilliSeconds(100),
+                                                 80,
+                                                 20,
+                                                 TcpLedbatCongestionAvoidanceTest::INCREMENT_TEST,
+                                                 "LEDBAT Congestion Avoidance Increment"),
+            TestCase::Duration::QUICK);
+        AddTestCase(new TcpLedbatCongestionAvoidanceTest(
+                        6 * 1446,
+                        1446,
+                        4 * 1446,
+                        2,
+                        3 * 1446,
+                        MilliSeconds(100),
+                        80,
+                        20,
+                        TcpLedbatCongestionAvoidanceTest::MAX_CWND_TEST,
+                        "LEDBAT Congestion Avoidance Increment (Limited by max_cwnd)"),
                     TestCase::Duration::QUICK);
-        AddTestCase(new TcpLedbatDecrementTest(2 * 1446,
-                                               1446,
-                                               4 * 1446,
-                                               2,
-                                               SequenceNumber32(4753),
-                                               SequenceNumber32(3216),
-                                               MilliSeconds(100),
-                                               "LEDBAT decrement test"),
+        AddTestCase(
+            new TcpLedbatCongestionAvoidanceTest(6 * 1446,
+                                                 1446,
+                                                 4 * 1446,
+                                                 2,
+                                                 4 * 1446,
+                                                 MilliSeconds(100),
+                                                 160,
+                                                 20,
+                                                 TcpLedbatCongestionAvoidanceTest::DECREMENT_TEST,
+                                                 "LEDBAT Congestion Avoidance Decrement"),
+            TestCase::Duration::QUICK);
+        AddTestCase(new TcpLedbatCongestionAvoidanceTest(
+                        2 * 1446,
+                        1446,
+                        4 * 1446,
+                        2,
+                        4 * 1446,
+                        MilliSeconds(100),
+                        160,
+                        20,
+                        TcpLedbatCongestionAvoidanceTest::MIN_CWND_TEST,
+                        "LEDBAT Congestion Avoidance Decrement (Limited by min_cwnd)"),
                     TestCase::Duration::QUICK);
     }
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet/test/tcp-test.cc ns-3.47/src/internet/test/tcp-test.cc
--- ns-3.46/src/internet/test/tcp-test.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet/test/tcp-test.cc	2026-02-16 16:08:49.627230000 -0800
@@ -432,9 +432,9 @@
 void
 TcpTestCase::SetupDefaultSim6()
 {
-    Ipv6Prefix prefix = Ipv6Prefix(64);
-    Ipv6Address ipaddr0 = Ipv6Address("2001:0100:f00d:cafe::1");
-    Ipv6Address ipaddr1 = Ipv6Address("2001:0100:f00d:cafe::2");
+    auto prefix = Ipv6Prefix(64);
+    auto ipaddr0 = Ipv6Address("2001:0100:f00d:cafe::1");
+    auto ipaddr1 = Ipv6Address("2001:0100:f00d:cafe::2");
     Ptr<Node> node0 = CreateInternetNode6();
     Ptr<Node> node1 = CreateInternetNode6();
     Ptr<SimpleNetDevice> dev0 = AddSimpleNetDevice6(node0, ipaddr0, prefix);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet-apps/examples/dhcp6-example.cc ns-3.47/src/internet-apps/examples/dhcp6-example.cc
--- ns-3.46/src/internet-apps/examples/dhcp6-example.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet-apps/examples/dhcp6-example.cc	2026-02-16 16:08:49.603230000 -0800
@@ -69,6 +69,7 @@
 #include "ns3/applications-module.h"
 #include "ns3/core-module.h"
 #include "ns3/csma-module.h"
+#include "ns3/enum.h"
 #include "ns3/internet-apps-module.h"
 #include "ns3/internet-module.h"
 #include "ns3/mobility-module.h"
@@ -169,6 +170,13 @@
     dhcp6Helper.SetServerAttribute("RebindTime", StringValue("16s"));
     dhcp6Helper.SetServerAttribute("PreferredLifetime", StringValue("18s"));
     dhcp6Helper.SetServerAttribute("ValidLifetime", StringValue("20s"));
+    // We set an arbitrary DUID type for the server.
+    // There is no universal standard for the server's DUID type.
+    dhcp6Helper.SetServerAttribute("DuidType", StringValue("LLT"));
+    // We set an arbitrary DUID type for the client.
+    // There is no universal standard for the client's DUID type,
+    // but usually OSes setup the DUID during the OS installation.
+    dhcp6Helper.SetClientAttribute("DuidType", StringValue("UUID"));
 
     // DHCPv6 clients
     NodeContainer nodes = NodeContainer(nonRouterNodes.Get(1), nonRouterNodes.Get(2));
